﻿using Ionic.Zip;
using Silanis.ESL.SDK;
using System.IO;

namespace FeatureGuideCharp
{
    class _20_06_08_unzip_byte_array
    {
        string apiKey = "your_api_key";
        string apiUrl = "https://sandbox.esignlive.com/api";

        public void Execute()
        {
            string packageId = "cPxmb6q7j9jotWV--k2apMmNcTk=";
            string documentName = "your_document_name.pdf";
            string downloadPath = "your_file_path\\your_document_name.pdf";
            UnzipDownloadedFiles(packageId,documentName, downloadPath);
        }


        public void UnzipDownloadedFiles(string packageId, string documentName, string downloadPath) {
            EslClient eslClient = new EslClient(apiKey, apiUrl);

            PackageId id = new PackageId(packageId);
            byte[] zippedDocuments = eslClient.DownloadZippedDocuments(id);

            MemoryStream data = new MemoryStream();
            using (ZipFile zip = ZipFile.Read(new MemoryStream(zippedDocuments)))
            {
                zip[documentName].Extract(data);
            }
            data.Seek(0, SeekOrigin.Begin);

            using (FileStream fs = new FileStream(downloadPath, FileMode.OpenOrCreate))
            {
                data.CopyTo(fs);
                fs.Flush();
            }

        }
    }
}
